#workflow:
 ## rules:
   # - if: $CI_COMMIT_BRANCH != "master" && $CI_PIPELINE_SOURCE != "merge_request_event"      
   #   when: never
   # - when: always

variables:
    SERVER: devups.ru
    USER: jollymolly
    VER: "2.3"

stages:
  - build
  - deploy


back:
  stage: build
  image: docker:latest
  variables:
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind

  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - cd backend
    - docker build --no-cache -t ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:${VER} .
    - docker push ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:${VER}
    - if [[ $CI_COMMIT_REF_SLUG == "master" ]]; then 
         docker tag ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:${VER} ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:latest; fi
    - if [[ $CI_COMMIT_REF_SLUG == "master" ]]; then
         docker push ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:latest; fi

  rules:
    - if: $CI_COMMIT_REF_NAME != "master"
    - when: never



front:
  stage: build
  image: docker:latest
  variables:
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - cd frontend
    - docker build --no-cache -t ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:${VER} .
    - docker push ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:${VER}
    - if [[ $CI_COMMIT_REF_SLUG == "master" ]]; then 
         docker tag ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:${VER} ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:latest; fi
    - if [[ $CI_COMMIT_REF_SLUG == "master" ]]; then
         docker push ${CI_REGISTRY_IMAGE}/$CI_JOB_NAME_SLUG:latest; fi

  rules:
   - if: $CI_COMMIT_REF_NAME != "master"
   - when: never





ansible build:
  stage: build
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - docker build -t ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG} ./ansimg
    - docker push ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG}

  tags:
    - docker
  rules:
   - if: $CI_COMMIT_REF_NAME != "master"


#deploy:
#  stage: deploy
#  tags:
#    - shell
#  before_script:
#    - chmod 400 $SSH_PK 
#  script:
#    - scp -r -o StrictHostKeyChecking=no -i $SSH_PK ./docker-compose.yml ./db ./nginx ./.env ${USER}@${SERVER}:/home/jollymolly
#    - ssh -i $SSH_PK -o StrictHostKeyChecking=no ${USER}@${SERVER} "
#      docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY} &&
#      export VER=$VER &&
#      docker-compose down &&
#      docker-compose up -d "


prepare serv:
  stage: deploy
  image: ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG}
  before_script:
    - export ANSIBLE_CONFIG=.cicd/ansible.cfg
    - chmod 600 ${SSH_PK}
    - export ANSIBLE_HOST_KEY_CHECKING=False
    
  script:
    - cd .cicd
    - export ANSIBLE_CONFIG=./ansible.cfg
    - ansible-playbook -u jollymolly --private-key ${SSH_PK} -i inventories/dev/hosts prepare.yml -D

  tags:
    - dock
  rules:
   - if: $CI_COMMIT_REF_NAME != "master"

deploy to dev:
  stage: deploy
  image: ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG}
  before_script:
    - export ANSIBLE_CONFIG=.cicd/ansible.cfg
    - chmod 600 ${SSH_PK}
    - export ANSIBLE_HOST_KEY_CHECKING=False
    
  script:
    - cd .cicd
    - export ANSIBLE_CONFIG=./ansible.cfg
    - ansible-playbook -u ansible --private-key ${SSH_PK} -i inventories/dev/hosts playbook.yml -D
  #needs: ["prepare serv"]
  tags:
    - dock
  